diff --git a/src/backend/access/transam/multixact.c b/src/backend/access/transam/multixact.c
new file mode 100644
index 1a7824b..a4b2c97
*** a/src/backend/access/transam/multixact.c
--- b/src/backend/access/transam/multixact.c
*************** pg_get_multixact_members(PG_FUNCTION_ARG
*** 3388,3394 ****
  		HeapTuple	tuple;
  		char	   *values[2];
  
! 		values[0] = psprintf("%u", multi->members[multi->iter].xid);
  		values[1] = mxstatus_to_string(multi->members[multi->iter].status);
  
  		tuple = BuildTupleFromCStrings(funccxt->attinmeta, values);
--- 2730,2736 ----
  		HeapTuple	tuple;
  		char	   *values[2];
  
! 		values[0] = psprintf(XID_FMT, multi->members[multi->iter].xid);
  		values[1] = mxstatus_to_string(multi->members[multi->iter].status);
  
  		tuple = BuildTupleFromCStrings(funccxt->attinmeta, values);
diff --git a/src/backend/access/transam/slru.c b/src/backend/access/transam/slru.c
new file mode 100644
index 7ae7831..f8ab0f9
*** a/src/backend/access/transam/slru.c
--- b/src/backend/access/transam/slru.c
***************
*** 58,67 ****
  #include "storage/fd.h"
  #include "storage/shmem.h"
  #include "miscadmin.h"
  
  
  #define SlruFileName(ctl, path, seg) \
! 	snprintf(path, MAXPGPATH, "%s/%04X", (ctl)->Dir, seg)
  
  /*
   * During SimpleLruFlush(), we will usually not need to write/fsync more
--- 58,69 ----
  #include "storage/fd.h"
  #include "storage/shmem.h"
  #include "miscadmin.h"
+ #include "utils/builtins.h"
  
  
  #define SlruFileName(ctl, path, seg) \
! 	snprintf(path, MAXPGPATH, "%s/%04X%08X", (ctl)->Dir, \
! 		(uint32) ((seg) >> 32), (uint32) ((seg) & (int64)0xFFFFFFFF))
  
  /*
   * During SimpleLruFlush(), we will usually not need to write/fsync more
*************** typedef struct SlruFlushData
*** 76,82 ****
  {
  	int			num_files;		/* # files actually open */
  	int			fd[MAX_FLUSH_BUFFERS];	/* their FD's */
! 	int			segno[MAX_FLUSH_BUFFERS];		/* their log seg#s */
  } SlruFlushData;
  
  typedef struct SlruFlushData *SlruFlush;
--- 78,84 ----
  {
  	int			num_files;		/* # files actually open */
  	int			fd[MAX_FLUSH_BUFFERS];	/* their FD's */
! 	int64		segno[MAX_FLUSH_BUFFERS];		/* their log seg#s */
  } SlruFlushData;
  
  typedef struct SlruFlushData *SlruFlush;
*************** static int	slru_errno;
*** 127,140 ****
  static void SimpleLruZeroLSNs(SlruCtl ctl, int slotno);
  static void SimpleLruWaitIO(SlruCtl ctl, int slotno);
  static void SlruInternalWritePage(SlruCtl ctl, int slotno, SlruFlush fdata);
! static bool SlruPhysicalReadPage(SlruCtl ctl, int pageno, int slotno);
! static bool SlruPhysicalWritePage(SlruCtl ctl, int pageno, int slotno,
  					  SlruFlush fdata);
! static void SlruReportIOError(SlruCtl ctl, int pageno, TransactionId xid);
! static int	SlruSelectLRUPage(SlruCtl ctl, int pageno);
  
  static bool SlruScanDirCbDeleteCutoff(SlruCtl ctl, char *filename,
! 						  int segpage, void *data);
  static void SlruInternalDeleteSegment(SlruCtl ctl, char *filename);
  
  /*
--- 129,142 ----
  static void SimpleLruZeroLSNs(SlruCtl ctl, int slotno);
  static void SimpleLruWaitIO(SlruCtl ctl, int slotno);
  static void SlruInternalWritePage(SlruCtl ctl, int slotno, SlruFlush fdata);
! static bool SlruPhysicalReadPage(SlruCtl ctl, int64 pageno, int slotno);
! static bool SlruPhysicalWritePage(SlruCtl ctl, int64 pageno, int slotno,
  					  SlruFlush fdata);
! static void SlruReportIOError(SlruCtl ctl, int64 pageno, TransactionId xid);
! static int	SlruSelectLRUPage(SlruCtl ctl, int64 pageno);
  
  static bool SlruScanDirCbDeleteCutoff(SlruCtl ctl, char *filename,
! 						  int64 segpage, void *data);
  static void SlruInternalDeleteSegment(SlruCtl ctl, char *filename);
  
  /*
*************** SimpleLruShmemSize(int nslots, int nlsns
*** 151,157 ****
  	sz += MAXALIGN(nslots * sizeof(char *));	/* page_buffer[] */
  	sz += MAXALIGN(nslots * sizeof(SlruPageStatus));	/* page_status[] */
  	sz += MAXALIGN(nslots * sizeof(bool));		/* page_dirty[] */
! 	sz += MAXALIGN(nslots * sizeof(int));		/* page_number[] */
  	sz += MAXALIGN(nslots * sizeof(int));		/* page_lru_count[] */
  	sz += MAXALIGN(nslots * sizeof(LWLockPadded));		/* buffer_locks[] */
  
--- 153,159 ----
  	sz += MAXALIGN(nslots * sizeof(char *));	/* page_buffer[] */
  	sz += MAXALIGN(nslots * sizeof(SlruPageStatus));	/* page_status[] */
  	sz += MAXALIGN(nslots * sizeof(bool));		/* page_dirty[] */
! 	sz += MAXALIGN(nslots * sizeof(int64));		/* page_number[] */
  	sz += MAXALIGN(nslots * sizeof(int));		/* page_lru_count[] */
  	sz += MAXALIGN(nslots * sizeof(LWLockPadded));		/* buffer_locks[] */
  
*************** SimpleLruInit(SlruCtl ctl, const char *n
*** 200,207 ****
  		offset += MAXALIGN(nslots * sizeof(SlruPageStatus));
  		shared->page_dirty = (bool *) (ptr + offset);
  		offset += MAXALIGN(nslots * sizeof(bool));
! 		shared->page_number = (int *) (ptr + offset);
! 		offset += MAXALIGN(nslots * sizeof(int));
  		shared->page_lru_count = (int *) (ptr + offset);
  		offset += MAXALIGN(nslots * sizeof(int));
  
--- 202,209 ----
  		offset += MAXALIGN(nslots * sizeof(SlruPageStatus));
  		shared->page_dirty = (bool *) (ptr + offset);
  		offset += MAXALIGN(nslots * sizeof(bool));
! 		shared->page_number = (int64 *) (ptr + offset);
! 		offset += MAXALIGN(nslots * sizeof(int64));
  		shared->page_lru_count = (int *) (ptr + offset);
  		offset += MAXALIGN(nslots * sizeof(int));
  
*************** SimpleLruInit(SlruCtl ctl, const char *n
*** 256,262 ****
   * Control lock must be held at entry, and will be held at exit.
   */
  int
! SimpleLruZeroPage(SlruCtl ctl, int pageno)
  {
  	SlruShared	shared = ctl->shared;
  	int			slotno;
--- 258,264 ----
   * Control lock must be held at entry, and will be held at exit.
   */
  int
! SimpleLruZeroPage(SlruCtl ctl, int64 pageno)
  {
  	SlruShared	shared = ctl->shared;
  	int			slotno;
*************** SimpleLruWaitIO(SlruCtl ctl, int slotno)
*** 368,374 ****
   * Control lock must be held at entry, and will be held at exit.
   */
  int
! SimpleLruReadPage(SlruCtl ctl, int pageno, bool write_ok,
  				  TransactionId xid)
  {
  	SlruShared	shared = ctl->shared;
--- 370,376 ----
   * Control lock must be held at entry, and will be held at exit.
   */
  int
! SimpleLruReadPage(SlruCtl ctl, int64 pageno, bool write_ok,
  				  TransactionId xid)
  {
  	SlruShared	shared = ctl->shared;
*************** SimpleLruReadPage(SlruCtl ctl, int pagen
*** 460,466 ****
   * It is unspecified whether the lock will be shared or exclusive.
   */
  int
! SimpleLruReadPage_ReadOnly(SlruCtl ctl, int pageno, TransactionId xid)
  {
  	SlruShared	shared = ctl->shared;
  	int			slotno;
--- 462,468 ----
   * It is unspecified whether the lock will be shared or exclusive.
   */
  int
! SimpleLruReadPage_ReadOnly(SlruCtl ctl, int64 pageno, TransactionId xid)
  {
  	SlruShared	shared = ctl->shared;
  	int			slotno;
*************** static void
*** 503,509 ****
  SlruInternalWritePage(SlruCtl ctl, int slotno, SlruFlush fdata)
  {
  	SlruShared	shared = ctl->shared;
! 	int			pageno = shared->page_number[slotno];
  	bool		ok;
  
  	/* If a write is in progress, wait for it to finish */
--- 505,511 ----
  SlruInternalWritePage(SlruCtl ctl, int slotno, SlruFlush fdata)
  {
  	SlruShared	shared = ctl->shared;
! 	int64		pageno = shared->page_number[slotno];
  	bool		ok;
  
  	/* If a write is in progress, wait for it to finish */
*************** SimpleLruWritePage(SlruCtl ctl, int slot
*** 583,591 ****
   * large enough to contain the given page.
   */
  bool
! SimpleLruDoesPhysicalPageExist(SlruCtl ctl, int pageno)
  {
! 	int			segno = pageno / SLRU_PAGES_PER_SEGMENT;
  	int			rpageno = pageno % SLRU_PAGES_PER_SEGMENT;
  	int			offset = rpageno * BLCKSZ;
  	char		path[MAXPGPATH];
--- 585,593 ----
   * large enough to contain the given page.
   */
  bool
! SimpleLruDoesPhysicalPageExist(SlruCtl ctl, int64 pageno)
  {
! 	int64		segno = pageno / SLRU_PAGES_PER_SEGMENT;
  	int			rpageno = pageno % SLRU_PAGES_PER_SEGMENT;
  	int			offset = rpageno * BLCKSZ;
  	char		path[MAXPGPATH];
*************** SimpleLruDoesPhysicalPageExist(SlruCtl c
*** 632,641 ****
   * read/write operations.  We could cache one virtual file pointer ...
   */
  static bool
! SlruPhysicalReadPage(SlruCtl ctl, int pageno, int slotno)
  {
  	SlruShared	shared = ctl->shared;
! 	int			segno = pageno / SLRU_PAGES_PER_SEGMENT;
  	int			rpageno = pageno % SLRU_PAGES_PER_SEGMENT;
  	int			offset = rpageno * BLCKSZ;
  	char		path[MAXPGPATH];
--- 634,643 ----
   * read/write operations.  We could cache one virtual file pointer ...
   */
  static bool
! SlruPhysicalReadPage(SlruCtl ctl, int64 pageno, int slotno)
  {
  	SlruShared	shared = ctl->shared;
! 	int64		segno = pageno / SLRU_PAGES_PER_SEGMENT;
  	int			rpageno = pageno % SLRU_PAGES_PER_SEGMENT;
  	int			offset = rpageno * BLCKSZ;
  	char		path[MAXPGPATH];
*************** SlruPhysicalReadPage(SlruCtl ctl, int pa
*** 712,721 ****
   * SimpleLruFlush.
   */
  static bool
! SlruPhysicalWritePage(SlruCtl ctl, int pageno, int slotno, SlruFlush fdata)
  {
  	SlruShared	shared = ctl->shared;
! 	int			segno = pageno / SLRU_PAGES_PER_SEGMENT;
  	int			rpageno = pageno % SLRU_PAGES_PER_SEGMENT;
  	int			offset = rpageno * BLCKSZ;
  	char		path[MAXPGPATH];
--- 714,723 ----
   * SimpleLruFlush.
   */
  static bool
! SlruPhysicalWritePage(SlruCtl ctl, int64 pageno, int slotno, SlruFlush fdata)
  {
  	SlruShared	shared = ctl->shared;
! 	int64		segno = pageno / SLRU_PAGES_PER_SEGMENT;
  	int			rpageno = pageno % SLRU_PAGES_PER_SEGMENT;
  	int			offset = rpageno * BLCKSZ;
  	char		path[MAXPGPATH];
*************** SlruPhysicalWritePage(SlruCtl ctl, int p
*** 886,894 ****
   * SlruPhysicalWritePage.  Call this after cleaning up shared-memory state.
   */
  static void
! SlruReportIOError(SlruCtl ctl, int pageno, TransactionId xid)
  {
! 	int			segno = pageno / SLRU_PAGES_PER_SEGMENT;
  	int			rpageno = pageno % SLRU_PAGES_PER_SEGMENT;
  	int			offset = rpageno * BLCKSZ;
  	char		path[MAXPGPATH];
--- 888,896 ----
   * SlruPhysicalWritePage.  Call this after cleaning up shared-memory state.
   */
  static void
! SlruReportIOError(SlruCtl ctl, int64 pageno, TransactionId xid)
  {
! 	int64		segno = pageno / SLRU_PAGES_PER_SEGMENT;
  	int			rpageno = pageno % SLRU_PAGES_PER_SEGMENT;
  	int			offset = rpageno * BLCKSZ;
  	char		path[MAXPGPATH];
*************** SlruReportIOError(SlruCtl ctl, int pagen
*** 900,940 ****
  		case SLRU_OPEN_FAILED:
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not access status of transaction %u", xid),
  					 errdetail("Could not open file \"%s\": %m.", path)));
  			break;
  		case SLRU_SEEK_FAILED:
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not access status of transaction %u", xid),
  				 errdetail("Could not seek in file \"%s\" to offset %u: %m.",
  						   path, offset)));
  			break;
  		case SLRU_READ_FAILED:
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not access status of transaction %u", xid),
  			   errdetail("Could not read from file \"%s\" at offset %u: %m.",
  						 path, offset)));
  			break;
  		case SLRU_WRITE_FAILED:
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not access status of transaction %u", xid),
  				errdetail("Could not write to file \"%s\" at offset %u: %m.",
  						  path, offset)));
  			break;
  		case SLRU_FSYNC_FAILED:
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not access status of transaction %u", xid),
  					 errdetail("Could not fsync file \"%s\": %m.",
  							   path)));
  			break;
  		case SLRU_CLOSE_FAILED:
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not access status of transaction %u", xid),
  					 errdetail("Could not close file \"%s\": %m.",
  							   path)));
  			break;
--- 902,942 ----
  		case SLRU_OPEN_FAILED:
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not access status of transaction " XID_FMT, xid),
  					 errdetail("Could not open file \"%s\": %m.", path)));
  			break;
  		case SLRU_SEEK_FAILED:
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not access status of transaction " XID_FMT, xid),
  				 errdetail("Could not seek in file \"%s\" to offset %u: %m.",
  						   path, offset)));
  			break;
  		case SLRU_READ_FAILED:
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not access status of transaction " XID_FMT, xid),
  			   errdetail("Could not read from file \"%s\" at offset %u: %m.",
  						 path, offset)));
  			break;
  		case SLRU_WRITE_FAILED:
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not access status of transaction " XID_FMT, xid),
  				errdetail("Could not write to file \"%s\" at offset %u: %m.",
  						  path, offset)));
  			break;
  		case SLRU_FSYNC_FAILED:
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not access status of transaction " XID_FMT, xid),
  					 errdetail("Could not fsync file \"%s\": %m.",
  							   path)));
  			break;
  		case SLRU_CLOSE_FAILED:
  			ereport(ERROR,
  					(errcode_for_file_access(),
! 					 errmsg("could not access status of transaction " XID_FMT, xid),
  					 errdetail("Could not close file \"%s\": %m.",
  							   path)));
  			break;
*************** SlruReportIOError(SlruCtl ctl, int pagen
*** 960,966 ****
   * Control lock must be held at entry, and will be held at exit.
   */
  static int
! SlruSelectLRUPage(SlruCtl ctl, int pageno)
  {
  	SlruShared	shared = ctl->shared;
  
--- 962,968 ----
   * Control lock must be held at entry, and will be held at exit.
   */
  static int
! SlruSelectLRUPage(SlruCtl ctl, int64 pageno)
  {
  	SlruShared	shared = ctl->shared;
  
*************** SlruSelectLRUPage(SlruCtl ctl, int pagen
*** 971,980 ****
  		int			cur_count;
  		int			bestvalidslot = 0;	/* keep compiler quiet */
  		int			best_valid_delta = -1;
! 		int			best_valid_page_number = 0; /* keep compiler quiet */
  		int			bestinvalidslot = 0;		/* keep compiler quiet */
  		int			best_invalid_delta = -1;
! 		int			best_invalid_page_number = 0;		/* keep compiler quiet */
  
  		/* See if page already has a buffer assigned */
  		for (slotno = 0; slotno < shared->num_slots; slotno++)
--- 973,982 ----
  		int			cur_count;
  		int			bestvalidslot = 0;	/* keep compiler quiet */
  		int			best_valid_delta = -1;
! 		int64		best_valid_page_number = 0; /* keep compiler quiet */
  		int			bestinvalidslot = 0;		/* keep compiler quiet */
  		int			best_invalid_delta = -1;
! 		int64		best_invalid_page_number = 0;		/* keep compiler quiet */
  
  		/* See if page already has a buffer assigned */
  		for (slotno = 0; slotno < shared->num_slots; slotno++)
*************** SlruSelectLRUPage(SlruCtl ctl, int pagen
*** 1015,1021 ****
  		for (slotno = 0; slotno < shared->num_slots; slotno++)
  		{
  			int			this_delta;
! 			int			this_page_number;
  
  			if (shared->page_status[slotno] == SLRU_PAGE_EMPTY)
  				return slotno;
--- 1017,1023 ----
  		for (slotno = 0; slotno < shared->num_slots; slotno++)
  		{
  			int			this_delta;
! 			int64		this_page_number;
  
  			if (shared->page_status[slotno] == SLRU_PAGE_EMPTY)
  				return slotno;
*************** SlruSelectLRUPage(SlruCtl ctl, int pagen
*** 1039,1046 ****
  			{
  				if (this_delta > best_valid_delta ||
  					(this_delta == best_valid_delta &&
! 					 ctl->PagePrecedes(this_page_number,
! 									   best_valid_page_number)))
  				{
  					bestvalidslot = slotno;
  					best_valid_delta = this_delta;
--- 1041,1047 ----
  			{
  				if (this_delta > best_valid_delta ||
  					(this_delta == best_valid_delta &&
! 					 this_page_number < best_valid_page_number))
  				{
  					bestvalidslot = slotno;
  					best_valid_delta = this_delta;
*************** SlruSelectLRUPage(SlruCtl ctl, int pagen
*** 1051,1058 ****
  			{
  				if (this_delta > best_invalid_delta ||
  					(this_delta == best_invalid_delta &&
! 					 ctl->PagePrecedes(this_page_number,
! 									   best_invalid_page_number)))
  				{
  					bestinvalidslot = slotno;
  					best_invalid_delta = this_delta;
--- 1052,1058 ----
  			{
  				if (this_delta > best_invalid_delta ||
  					(this_delta == best_invalid_delta &&
! 					 this_page_number < best_invalid_page_number))
  				{
  					bestinvalidslot = slotno;
  					best_invalid_delta = this_delta;
*************** SimpleLruFlush(SlruCtl ctl, bool allow_r
*** 1102,1108 ****
  	SlruShared	shared = ctl->shared;
  	SlruFlushData fdata;
  	int			slotno;
! 	int			pageno = 0;
  	int			i;
  	bool		ok;
  
--- 1102,1108 ----
  	SlruShared	shared = ctl->shared;
  	SlruFlushData fdata;
  	int			slotno;
! 	int64		pageno = 0;
  	int			i;
  	bool		ok;
  
*************** SimpleLruFlush(SlruCtl ctl, bool allow_r
*** 1162,1168 ****
   * Remove all segments before the one holding the passed page number
   */
  void
! SimpleLruTruncate(SlruCtl ctl, int cutoffPage)
  {
  	SlruShared	shared = ctl->shared;
  	int			slotno;
--- 1162,1168 ----
   * Remove all segments before the one holding the passed page number
   */
  void
! SimpleLruTruncate(SlruCtl ctl, int64 cutoffPage)
  {
  	SlruShared	shared = ctl->shared;
  	int			slotno;
*************** restart:;
*** 1188,1194 ****
  	 * have already wrapped around, and proceeding with the truncation would
  	 * risk removing the current segment.
  	 */
! 	if (ctl->PagePrecedes(shared->latest_page_number, cutoffPage))
  	{
  		LWLockRelease(shared->ControlLock);
  		ereport(LOG,
--- 1188,1194 ----
  	 * have already wrapped around, and proceeding with the truncation would
  	 * risk removing the current segment.
  	 */
! 	if (shared->latest_page_number < cutoffPage)
  	{
  		LWLockRelease(shared->ControlLock);
  		ereport(LOG,
*************** restart:;
*** 1201,1207 ****
  	{
  		if (shared->page_status[slotno] == SLRU_PAGE_EMPTY)
  			continue;
! 		if (!ctl->PagePrecedes(shared->page_number[slotno], cutoffPage))
  			continue;
  
  		/*
--- 1201,1207 ----
  	{
  		if (shared->page_status[slotno] == SLRU_PAGE_EMPTY)
  			continue;
! 		if (shared->page_number[slotno] >= cutoffPage)
  			continue;
  
  		/*
*************** SlruInternalDeleteSegment(SlruCtl ctl, c
*** 1255,1261 ****
   * Delete an individual SLRU segment, identified by the segment number.
   */
  void
! SlruDeleteSegment(SlruCtl ctl, int segno)
  {
  	SlruShared	shared = ctl->shared;
  	int			slotno;
--- 1255,1261 ----
   * Delete an individual SLRU segment, identified by the segment number.
   */
  void
! SlruDeleteSegment(SlruCtl ctl, int64 segno)
  {
  	SlruShared	shared = ctl->shared;
  	int			slotno;
*************** restart:
*** 1301,1307 ****
  	if (did_write)
  		goto restart;
  
! 	snprintf(path, MAXPGPATH, "%s/%04X", ctl->Dir, segno);
  	ereport(DEBUG2,
  			(errmsg("removing file \"%s\"", path)));
  	unlink(path);
--- 1301,1307 ----
  	if (did_write)
  		goto restart;
  
! 	SlruFileName(ctl, path, segno);
  	ereport(DEBUG2,
  			(errmsg("removing file \"%s\"", path)));
  	unlink(path);
*************** restart:
*** 1315,1327 ****
   *		containing the page passed as "data".
   */
  bool
! SlruScanDirCbReportPresence(SlruCtl ctl, char *filename, int segpage, void *data)
  {
! 	int			cutoffPage = *(int *) data;
  
  	cutoffPage -= cutoffPage % SLRU_PAGES_PER_SEGMENT;
  
! 	if (ctl->PagePrecedes(segpage, cutoffPage))
  		return true;			/* found one; don't iterate any more */
  
  	return false;				/* keep going */
--- 1315,1327 ----
   *		containing the page passed as "data".
   */
  bool
! SlruScanDirCbReportPresence(SlruCtl ctl, char *filename, int64 segpage, void *data)
  {
! 	int64		cutoffPage = *(int64 *) data;
  
  	cutoffPage -= cutoffPage % SLRU_PAGES_PER_SEGMENT;
  
! 	if (segpage < cutoffPage)
  		return true;			/* found one; don't iterate any more */
  
  	return false;				/* keep going */
*************** SlruScanDirCbReportPresence(SlruCtl ctl,
*** 1332,1342 ****
   *		This callback deletes segments prior to the one passed in as "data".
   */
  static bool
! SlruScanDirCbDeleteCutoff(SlruCtl ctl, char *filename, int segpage, void *data)
  {
! 	int			cutoffPage = *(int *) data;
  
! 	if (ctl->PagePrecedes(segpage, cutoffPage))
  		SlruInternalDeleteSegment(ctl, filename);
  
  	return false;				/* keep going */
--- 1332,1342 ----
   *		This callback deletes segments prior to the one passed in as "data".
   */
  static bool
! SlruScanDirCbDeleteCutoff(SlruCtl ctl, char *filename, int64 segpage, void *data)
  {
! 	int64		cutoffPage = *(int64 *) data;
  
! 	if (segpage < cutoffPage)
  		SlruInternalDeleteSegment(ctl, filename);
  
  	return false;				/* keep going */
*************** SlruScanDirCbDeleteCutoff(SlruCtl ctl, c
*** 1347,1353 ****
   *		This callback deletes all segments.
   */
  bool
! SlruScanDirCbDeleteAll(SlruCtl ctl, char *filename, int segpage, void *data)
  {
  	SlruInternalDeleteSegment(ctl, filename);
  
--- 1347,1353 ----
   *		This callback deletes all segments.
   */
  bool
! SlruScanDirCbDeleteAll(SlruCtl ctl, char *filename, int64 segpage, void *data)
  {
  	SlruInternalDeleteSegment(ctl, filename);
  
*************** SlruScanDirectory(SlruCtl ctl, SlruScanC
*** 1375,1382 ****
  	bool		retval = false;
  	DIR		   *cldir;
  	struct dirent *clde;
! 	int			segno;
! 	int			segpage;
  
  	cldir = AllocateDir(ctl->Dir);
  	while ((clde = ReadDir(cldir, ctl->Dir)) != NULL)
--- 1375,1382 ----
  	bool		retval = false;
  	DIR		   *cldir;
  	struct dirent *clde;
! 	int64		segno;
! 	int64		segpage;
  
  	cldir = AllocateDir(ctl->Dir);
  	while ((clde = ReadDir(cldir, ctl->Dir)) != NULL)
*************** SlruScanDirectory(SlruCtl ctl, SlruScanC
*** 1385,1394 ****
  
  		len = strlen(clde->d_name);
  
! 		if ((len == 4 || len == 5 || len == 6) &&
  			strspn(clde->d_name, "0123456789ABCDEF") == len)
  		{
! 			segno = (int) strtol(clde->d_name, NULL, 16);
  			segpage = segno * SLRU_PAGES_PER_SEGMENT;
  
  			elog(DEBUG2, "SlruScanDirectory invoking callback on %s/%s",
--- 1385,1394 ----
  
  		len = strlen(clde->d_name);
  
! 		if ((len == 12 || len == 13 || len == 14) &&
  			strspn(clde->d_name, "0123456789ABCDEF") == len)
  		{
! 			segno = pg_strtouint64(clde->d_name, NULL, 16);
  			segpage = segno * SLRU_PAGES_PER_SEGMENT;
  
  			elog(DEBUG2, "SlruScanDirectory invoking callback on %s/%s",
diff --git a/src/backend/access/transam/subtrans.c b/src/backend/access/transam/subtrans.c
new file mode 100644
index f640661..cc9eee6
*** a/src/backend/access/transam/subtrans.c
--- b/src/backend/access/transam/subtrans.c
*************** static SlruCtlData SubTransCtlData;
*** 63,70 ****
  #define SubTransCtl  (&SubTransCtlData)
  
  
! static int	ZeroSUBTRANSPage(int pageno);
! static bool SubTransPagePrecedes(int page1, int page2);
  
  
  /*
--- 63,69 ----
  #define SubTransCtl  (&SubTransCtlData)
  
  
! static int	ZeroSUBTRANSPage(int64 pageno);
  
  
  /*
*************** static bool SubTransPagePrecedes(int pag
*** 73,79 ****
  void
  SubTransSetParent(TransactionId xid, TransactionId parent)
  {
! 	int			pageno = TransactionIdToPage(xid);
  	int			entryno = TransactionIdToEntry(xid);
  	int			slotno;
  	TransactionId *ptr;
--- 72,78 ----
  void
  SubTransSetParent(TransactionId xid, TransactionId parent)
  {
! 	int64		pageno = TransactionIdToPage(xid);
  	int			entryno = TransactionIdToEntry(xid);
  	int			slotno;
  	TransactionId *ptr;
*************** SubTransSetParent(TransactionId xid, Tra
*** 108,114 ****
  TransactionId
  SubTransGetParent(TransactionId xid)
  {
! 	int			pageno = TransactionIdToPage(xid);
  	int			entryno = TransactionIdToEntry(xid);
  	int			slotno;
  	TransactionId *ptr;
--- 107,113 ----
  TransactionId
  SubTransGetParent(TransactionId xid)
  {
! 	int64		pageno = TransactionIdToPage(xid);
  	int			entryno = TransactionIdToEntry(xid);
  	int			slotno;
  	TransactionId *ptr;
*************** SubTransGetTopmostTransaction(Transactio
*** 168,174 ****
  		 * structure that could lead to an infinite loop, so exit.
  		 */
  		if (!TransactionIdPrecedes(parentXid, previousXid))
! 			elog(ERROR, "pg_subtrans contains invalid entry: xid %u points to parent xid %u",
  				 previousXid, parentXid);
  	}
  
--- 167,173 ----
  		 * structure that could lead to an infinite loop, so exit.
  		 */
  		if (!TransactionIdPrecedes(parentXid, previousXid))
! 			elog(ERROR, "pg_subtrans contains invalid entry: xid " XID_FMT " points to parent xid " XID_FMT,
  				 previousXid, parentXid);
  	}
  
*************** SUBTRANSShmemSize(void)
*** 190,196 ****
  void
  SUBTRANSShmemInit(void)
  {
- 	SubTransCtl->PagePrecedes = SubTransPagePrecedes;
  	SimpleLruInit(SubTransCtl, "subtrans", NUM_SUBTRANS_BUFFERS, 0,
  				  SubtransControlLock, "pg_subtrans",
  				  LWTRANCHE_SUBTRANS_BUFFERS);
--- 189,194 ----
*************** BootStrapSUBTRANS(void)
*** 234,240 ****
   * Control lock must be held at entry, and will be held at exit.
   */
  static int
! ZeroSUBTRANSPage(int pageno)
  {
  	return SimpleLruZeroPage(SubTransCtl, pageno);
  }
--- 232,238 ----
   * Control lock must be held at entry, and will be held at exit.
   */
  static int
! ZeroSUBTRANSPage(int64 pageno)
  {
  	return SimpleLruZeroPage(SubTransCtl, pageno);
  }
*************** ZeroSUBTRANSPage(int pageno)
*** 249,256 ****
  void
  StartupSUBTRANS(TransactionId oldestActiveXID)
  {
! 	int			startPage;
! 	int			endPage;
  
  	/*
  	 * Since we don't expect pg_subtrans to be valid across crashes, we
--- 247,254 ----
  void
  StartupSUBTRANS(TransactionId oldestActiveXID)
  {
! 	int64		startPage;
! 	int64		endPage;
  
  	/*
  	 * Since we don't expect pg_subtrans to be valid across crashes, we
*************** StartupSUBTRANS(TransactionId oldestActi
*** 267,275 ****
  	{
  		(void) ZeroSUBTRANSPage(startPage);
  		startPage++;
- 		/* must account for wraparound */
- 		if (startPage > TransactionIdToPage(MaxTransactionId))
- 			startPage = 0;
  	}
  	(void) ZeroSUBTRANSPage(startPage);
  
--- 265,270 ----
*************** CheckPointSUBTRANS(void)
*** 323,329 ****
  void
  ExtendSUBTRANS(TransactionId newestXact)
  {
! 	int			pageno;
  
  	/*
  	 * No work except at first XID of a page.  But beware: just after
--- 318,324 ----
  void
  ExtendSUBTRANS(TransactionId newestXact)
  {
! 	int64		pageno;
  
  	/*
  	 * No work except at first XID of a page.  But beware: just after
*************** ExtendSUBTRANS(TransactionId newestXact)
*** 353,360 ****
  void
  TruncateSUBTRANS(TransactionId oldestXact)
  {
- 	int			cutoffPage;
- 
  	/*
  	 * The cutoff point is the start of the segment containing oldestXact. We
  	 * pass the *page* containing oldestXact to SimpleLruTruncate.  We step
--- 348,353 ----
*************** TruncateSUBTRANS(TransactionId oldestXac
*** 363,394 ****
  	 * a page and oldestXact == next XID.  In that case, if we didn't subtract
  	 * one, we'd trigger SimpleLruTruncate's wraparound detection.
  	 */
! 	TransactionIdRetreat(oldestXact);
! 	cutoffPage = TransactionIdToPage(oldestXact);
! 
! 	SimpleLruTruncate(SubTransCtl, cutoffPage);
! }
! 
! 
! /*
!  * Decide which of two SUBTRANS page numbers is "older" for truncation purposes.
!  *
!  * We need to use comparison of TransactionIds here in order to do the right
!  * thing with wraparound XID arithmetic.  However, if we are asked about
!  * page number zero, we don't want to hand InvalidTransactionId to
!  * TransactionIdPrecedes: it'll get weird about permanent xact IDs.  So,
!  * offset both xids by FirstNormalTransactionId to avoid that.
!  */
! static bool
! SubTransPagePrecedes(int page1, int page2)
! {
! 	TransactionId xid1;
! 	TransactionId xid2;
! 
! 	xid1 = ((TransactionId) page1) * SUBTRANS_XACTS_PER_PAGE;
! 	xid1 += FirstNormalTransactionId;
! 	xid2 = ((TransactionId) page2) * SUBTRANS_XACTS_PER_PAGE;
! 	xid2 += FirstNormalTransactionId;
  
! 	return TransactionIdPrecedes(xid1, xid2);
  }
--- 356,371 ----
  	 * a page and oldestXact == next XID.  In that case, if we didn't subtract
  	 * one, we'd trigger SimpleLruTruncate's wraparound detection.
  	 */
! 	if (oldestXact > FirstNormalTransactionId)
! 	{
! 		int64		cutoffPage;
! 		TransactionIdRetreat(oldestXact);
! 		cutoffPage = TransactionIdToPage(oldestXact);
  
! 		SimpleLruTruncate(SubTransCtl, cutoffPage);
! 	}
! 	else
! 	{
! 		SimpleLruTruncate(SubTransCtl, 0);
! 	}
  }
diff --git a/src/backend/access/transam/transam.c b/src/backend/access/transam/transam.c
new file mode 100644
index 968b232..36ca4ff
*** a/src/backend/access/transam/transam.c
--- b/src/backend/access/transam/transam.c
*************** TransactionIdDidCommit(TransactionId tra
*** 157,163 ****
  		parentXid = SubTransGetParent(transactionId);
  		if (!TransactionIdIsValid(parentXid))
  		{
! 			elog(WARNING, "no pg_subtrans entry for subcommitted XID %u",
  				 transactionId);
  			return false;
  		}
--- 157,163 ----
  		parentXid = SubTransGetParent(transactionId);
  		if (!TransactionIdIsValid(parentXid))
  		{
! 			elog(WARNING, "no pg_subtrans entry for subcommitted XID " XID_FMT,
  				 transactionId);
  			return false;
  		}
*************** TransactionIdDidAbort(TransactionId tran
*** 206,212 ****
  		if (!TransactionIdIsValid(parentXid))
  		{
  			/* see notes in TransactionIdDidCommit */
! 			elog(WARNING, "no pg_subtrans entry for subcommitted XID %u",
  				 transactionId);
  			return true;
  		}
--- 206,212 ----
  		if (!TransactionIdIsValid(parentXid))
  		{
  			/* see notes in TransactionIdDidCommit */
! 			elog(WARNING, "no pg_subtrans entry for subcommitted XID " XID_FMT,
  				 transactionId);
  			return true;
  		}
*************** TransactionIdAbortTree(TransactionId xid
*** 293,362 ****
  							   TRANSACTION_STATUS_ABORTED, InvalidXLogRecPtr);
  }
  
- /*
-  * TransactionIdPrecedes --- is id1 logically < id2?
-  */
- bool
- TransactionIdPrecedes(TransactionId id1, TransactionId id2)
- {
- 	/*
- 	 * If either ID is a permanent XID then we can just do unsigned
- 	 * comparison.  If both are normal, do a modulo-2^32 comparison.
- 	 */
- 	int32		diff;
- 
- 	if (!TransactionIdIsNormal(id1) || !TransactionIdIsNormal(id2))
- 		return (id1 < id2);
- 
- 	diff = (int32) (id1 - id2);
- 	return (diff < 0);
- }
- 
- /*
-  * TransactionIdPrecedesOrEquals --- is id1 logically <= id2?
-  */
- bool
- TransactionIdPrecedesOrEquals(TransactionId id1, TransactionId id2)
- {
- 	int32		diff;
- 
- 	if (!TransactionIdIsNormal(id1) || !TransactionIdIsNormal(id2))
- 		return (id1 <= id2);
- 
- 	diff = (int32) (id1 - id2);
- 	return (diff <= 0);
- }
- 
- /*
-  * TransactionIdFollows --- is id1 logically > id2?
-  */
- bool
- TransactionIdFollows(TransactionId id1, TransactionId id2)
- {
- 	int32		diff;
- 
- 	if (!TransactionIdIsNormal(id1) || !TransactionIdIsNormal(id2))
- 		return (id1 > id2);
- 
- 	diff = (int32) (id1 - id2);
- 	return (diff > 0);
- }
- 
- /*
-  * TransactionIdFollowsOrEquals --- is id1 logically >= id2?
-  */
- bool
- TransactionIdFollowsOrEquals(TransactionId id1, TransactionId id2)
- {
- 	int32		diff;
- 
- 	if (!TransactionIdIsNormal(id1) || !TransactionIdIsNormal(id2))
- 		return (id1 >= id2);
- 
- 	diff = (int32) (id1 - id2);
- 	return (diff >= 0);
- }
- 
  
  /*
   * TransactionIdLatest --- get latest XID among a main xact and its children
--- 293,298 ----
